/*
writen Vitus  24.06.2009
megavitus@yandex.ru
ICQ#: 324790154

free to modify
*/

-- The Jacobi Method for Finding the Eigenvalue and Eigenvectors
-- of Symmetric Matrices. 
 fn Jacobi  n &a &d &v  = ( 
	local i, j, p, q, rot, sm, g, theta, t, tresh, c, s, tau, h
	local z=#()
	local b=#()
	for i =1 to n do(
		z[i] =0.0
		b[i] = a[i][i]
		d[i] = a[i][i]
		for j=1 to n do
		 if (i == j) then v[i][j] = 1.0
		 	       else v[i][j] = 0.0
	)
	rot =0
	for i =1 to 50 do(
		sm = 0.0
		for p = 1 to n-1 do
		 for q=p+1 to n do sm += abs(a[p][q])
		if ( sm == 0 ) then exit()
		tresh = case ( i<4 ) of(
			true: 0.2*sm/(n*n)
			false: 0.0
		)
		for p =1 to n-1 do(
			for q = p+1 to n do (
				g = 1e12 * abs ( a[p][q] )
				if ((i>4) and ( abs(d[p])>g ) and ( abs(d[q])>g )) then (a[p][q] = 0.0)
				else 
				if ( abs( a[p][q] ) > tresh ) then(
					theta = 0.5 * ( d[q] - d[p] ) / a[p][q]
					t = 1.0 / ( abs(theta) + sqrt(1.0+theta*theta) )
					if ( theta < 0 ) then t = - t
					c = 1.0 / sqrt ( 1.0 + t*t )
                    			s = t * c
                    			tau = s / ( 1.0 + c )
                    			h = t * a[p][q]
					z[p] -= h
					z[q] += h
					d[p] -= h
                    			d[q] += h
                    			a[p][q] = 0.0
					for j=1 to p-1 do   (
						g = a[j][p]
						h = a[j][q]
						a[j][p] = g - s * ( h + g * tau )
						a[j][q] = h + s * ( g - h * tau )
					)
					for j=p+1 to q-1 do(
						g = a[p][j]
						h = a[j][q]
						a[p][j] = g - s * ( h + g * tau )
						a[j][q] = h + s * ( g - h * tau )
					)
					for j=q+1 to n do(
						g = a[p][j]
						h = a[q][j]
						a[p][j] = g - s * ( h + g * tau )
						a[q][j] = h + s * ( g - h * tau )
					)
					for j=1 to n do(
						g = v[j][p]
						h = v[j][q]
						v[j][p] = g - s * ( h + g * tau )
						v[j][q] = h + s * ( g - h * tau )
					)
					rot += 1
				)				
			)
		)
		for p =1 to n do(
			b[p] += z[p] 
			d[p] = b[p]			
			z[p] = 0.0
		)
	)--for i =1 to 50
	return rot
)--fn Jacobi

fn eigsrt n &d &v = (
  local  k, j, i, p, m
  for i=1 to n-1 do (
  	p=d[k=i]
    for j=i+1 to n do (if (d[j]>=p) then (p=d[k=j]))
    if (k!=i) then (
      d[k]=d[i]; d[i]=p
      for j=1 to n do (p=v[j][i]; v[j][i]=v[j][k]; v[j][k]=p) 
	)
   )
)--fn eigsrt

fn GetApproxVec &v uvw_space=(
	local a, i, point=[0,0,0]
	for i in v do point += i
	point /= v.count
	local xx = xy = xz = yy = yz = zz = 0.0
	for i in v do(
		local u = i - point
		xx += u.x * u.x
		xy += u.x * u.y
		xz += u.x * u.z
		yy += u.y * u.y
		yz += u.y * u.z
		zz += u.z * u.z
	)
	
	--define Symmetric Matrix
  	case uvw_space of(
  		1: (a = #([ xx, xy ],
					  [ xy, yy ]))
  		2: (a = #([ yy, yz ],
					  [ yz, zz ]))
  		3: (a = #([ zz, xz ],
					  [ xz, xx]))
  	)--case

	--Eigenvalue
	local d = #(0.0, 0.0)
	
	--Eigenvectors	 
	local u = #([ 0, 0 ],
					 [ 0, 0 ])

	--finding the Eigenvalue and Eigenvectors
	jacobi  2 &a &d &u
	--sort
	eigsrt 2 &d &u
	[u[1].x, u[2].x, 0] --return approximate line dir
)--fn GetApproxVec

obj = modPanel.getCurrentObject()

if classof (obj) == Unwrap_UVW then (
	local uv1, uv2, ctime, space, arrv, arrp, v1, correctionAngle
undo off(
	uv1 = obj.unwrap
	uv2 = obj.unwrap2
	
	case uv2.getTVSubObjectMode() of(
		2: uv2.edgeToVertSelect()
		3: uv2.faceToVertSelect()
	)
	
	ctime = currenttime
	space = uv1.getUVSpace()
	arrv = uv1.getSelectedVertices() as array
	arrp = for i in arrv collect (uv1.getVertexPosition ctime i)
	v1 = GetApproxVec &arrp space
	correctionAngle = acos( dot v1 [1,0,0] )
	if v1.y<0 then correctionAngle=-correctionAngle
)--undo off
	uv1.rotateSelectedVerticesCenter (degToRad -correctionAngle)
)--if classof (modPanel.g
